"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var utils_1 = require("./utils");
var lodash_throttle_1 = __importDefault(require("lodash.throttle"));
// import Header from "./components/header";
var container_1 = __importDefault(require("./components/container"));
var info_1 = __importDefault(require("./components/info"));
var message_1 = __importDefault(require("./components/message"));
var image_1 = __importDefault(require("./components/image"));
var audio_1 = __importDefault(require("./components/audio"));
var input_1 = __importDefault(require("./components/input"));
var more_1 = __importDefault(require("./components/more"));
var types_1 = require("./types");
var useReducer = react_1.default.useReducer, useRef = react_1.default.useRef, useEffect = react_1.default.useEffect;
var cs = utils_1.createCs("component-chat");
var initReducerData = {
    moreVisible: false,
    inputFocus: false,
    // messageList: messageListDefault,
    defaultContainerHeight: window.outerHeight,
    containerHeight: window.outerHeight,
};
var reducer = function (state, action) {
    switch (action.type) {
        case "changeMoreVisible":
            return __assign(__assign({}, state), { moreVisible: Boolean(action.value), inputFocus: false });
        case "inputFocusStatus":
            return __assign(__assign({}, state), { inputFocus: Boolean(action.value), moreVisible: false });
        // case "sendMessage":
        //   const newMessageList = [...state.messageList];
        //   newMessageList.push(action.value);
        //   return {
        //     ...state,
        //     messageList: newMessageList,
        //   };
        case "changeDefaultContainerHeight":
            return __assign(__assign({}, state), { defaultContainerHeight: Number(action.value) });
        case "changeContainerHeight":
            return __assign(__assign({}, state), { containerHeight: Number(action.value) });
        default:
            throw new Error("no action type");
    }
};
var Chat = function (props) {
    var _a, _b;
    var messageList = props.messageList, onSendMessageProp = props.onSendMessage, _c = props.moreHeight, moreHeight = _c === void 0 ? 0 : _c, onClickPhoto = props.onClickPhoto, onMoveToTop = props.onMoveToTop, renderCustomMessage = props.renderCustomMessage, onClickImage = props.onClickImage, _d = props.disable, disable = _d === void 0 ? false : _d;
    var containerRef = useRef();
    var touchStartRef = useRef();
    var _e = useReducer(reducer, __assign(__assign({}, initReducerData), { moreHeight: moreHeight })), chatData = _e[0], dispatch = _e[1];
    var isFull = ((_a = containerRef.current) === null || _a === void 0 ? void 0 : _a.scrollHeight) <= ((_b = containerRef.current) === null || _b === void 0 ? void 0 : _b.clientHeight);
    var changeMoreVisible = function (type) {
        dispatch({ type: "changeMoreVisible", value: type });
        if (type) {
            document.getElementById("testInput").blur();
            scrollGoContainerBottom();
            scrollGoWindowBottom();
        }
    };
    var onInputFocus = function () {
        dispatch({ type: "inputFocusStatus", value: true });
    };
    var onInputBlur = function () {
        dispatch({ type: "inputFocusStatus", value: false });
    };
    var onSendMessage = function (value) {
        onSendMessageProp(value);
    };
    var scrollGoContainerBottom = function () {
        containerRef.current.scrollTo({
            top: Date.now(),
            behavior: "smooth",
        });
    };
    var scrollGoWindowBottom = function () {
        // window.scrollTo(0, document.body.scrollHeight);
        window.scrollTo(0, 0);
    };
    var checkOpenKeyboardOnScroll = function () {
        if (chatData.inputFocus) {
            onInputBlur();
            document.getElementById("testInput").blur();
        }
        if (chatData.moreVisible) {
            changeMoreVisible(false);
        }
    };
    useEffect(function () {
        if (isFull) {
            setTimeout(scrollGoWindowBottom, 100);
        }
        else {
            scrollGoWindowBottom();
        }
        if (chatData.inputFocus) {
            setTimeout(scrollGoContainerBottom, 350);
        }
    }, [chatData.inputFocus]);
    useEffect(function () {
        // scrollGoWindowBottom();
        if (chatData.moreVisible) {
            setTimeout(scrollGoContainerBottom, 200);
        }
        // if (chatData.inputFocus) {
        // }
    }, [chatData.moreVisible]);
    useEffect(function () {
        scrollGoContainerBottom();
    }, [messageList.length]);
    useEffect(function () {
        setTimeout(function () {
            scrollGoContainerBottom();
        }, 100);
        var onTouchMove = lodash_throttle_1.default(function (e) {
            var yDiff = touchStartRef.current.clientY - e.touches[0].clientY;
            if (containerRef.current.scrollHeight -
                containerRef.current.scrollTop -
                containerRef.current.clientHeight <=
                0 &&
                yDiff > 0) {
                // containerRef.current.style.touchAction = "none";
                e.preventDefault();
            }
            else {
                // containerRef.current.style.touchAction = "auto";
            }
        }, 200);
        containerRef.current.addEventListener("touchmove", onTouchMove, false);
        containerRef.current.addEventListener("touchstart", function (e) {
            touchStartRef.current = e.touches[0];
        }, false);
        containerRef.current.addEventListener("touchend", function () {
            if (containerRef.current.scrollTop <= 0 &&
                typeof onMoveToTop === "function") {
                onMoveToTop();
            }
        }, false);
    }, []);
    //
    useEffect(function () {
        var onTouchMove = lodash_throttle_1.default(function (e) {
            var yDiff = touchStartRef.current.clientY - e.touches[0].clientY;
            if (yDiff <= 0) {
                checkOpenKeyboardOnScroll();
            }
        }, 1000);
        containerRef.current.addEventListener("touchmove", onTouchMove, false);
        return function () {
            containerRef.current.removeEventListener("touchmove", onTouchMove, false);
        };
    }, [chatData.inputFocus, chatData.moreVisible]);
    var containerStyle = {
        height: "100vh",
    };
    if (chatData.moreHeight > 0) {
        containerStyle.height = "calc(100vh - " + chatData.moreHeight + "px)";
    }
    return (react_1.default.createElement("div", { className: cs("root"), style: containerStyle },
        react_1.default.createElement(container_1.default, { containerRef: containerRef, chatData: chatData, disable: disable }, messageList.map(function (item, index) {
            var itemKey = "message.item." + index;
            if (item.type === "info") {
                return react_1.default.createElement(info_1.default, { key: itemKey, text: item.text });
            }
            else if (item.type === "message") {
                return (react_1.default.createElement(message_1.default, { key: itemKey, type: item.author === "master"
                        ? types_1.AuthorTypes.master
                        : types_1.AuthorTypes.guest, text: item.text, avatarUrl: item.authorUrl }));
            }
            else if (item.type === "image") {
                return (react_1.default.createElement(image_1.default, { key: itemKey, type: item.author === "master"
                        ? types_1.AuthorTypes.master
                        : types_1.AuthorTypes.guest, text: item.text, avatarUrl: item.authorUrl, onClick: onClickImage }));
            }
            else if (item.type === "audio") {
                return (react_1.default.createElement(audio_1.default, { key: itemKey, type: item.author === "master"
                        ? types_1.AuthorTypes.master
                        : types_1.AuthorTypes.guest, text: item.text, avatarUrl: item.authorUrl, readStatus: item.readStatus }));
            }
            else if (item.type === "custom") {
                return renderCustomMessage(item, itemKey);
            }
        })),
        disable ? null : (react_1.default.createElement(input_1.default, { chatData: chatData, onClickMore: changeMoreVisible, onFocus: onInputFocus, onBlur: onInputBlur, onSendMessage: onSendMessage })),
        disable ? null : (react_1.default.createElement(more_1.default, { moreVisible: chatData.moreVisible, onClickPhoto: onClickPhoto }))));
};
exports.default = Chat;
